# AUTOGENERATED! DO NOT EDIT! File to edit: nbs/11_inter_widgets.ipynb (unless otherwise specified).

__all__ = ['display_df', 'search_box']

# Cell
import pandas as pd
import numpy as np
from ipywidgets import interact,interact_manual
from IPython.display import HTML

# Cell
def display_df(df):display(df)

def search_box(df,columns,manual = False,max_rows = 10,callback = display_df):
    """
    create a search box based on dataframe
    df: pandas dataframe
    columns: str, dataframe field name
    manual: bool, search the dataframe on when click the button(manual=True),
        or on keypress reaction to inputbox (manual=False), default False
    max_rows:int, max rows of show result, default 10
    callback: python callable, discribe the action you want to put on
        search result (a filtered dataframe), default is to display the dataframe
    """
    intera = interact_manual if manual else interact

    @intera
    def search(KeyWord = "",):
        for col in columns:
            result = df[col].fillna("NaN Value").str.contains(KeyWord)
            if sum(result)>0:
                display(HTML(f"<h3>\"{KeyWord}\" matched on column:[{col}]</h3>"))
                callback(df[result].head(max_rows))
                return
        print(f"Nothing found on any column on keyword:{KeyWord}")
        return